#ifndef __CB_IOCTL__
#define __CB_IOCTL__

/**********************************************************************************
 * CHARBUF bc_ioctl.c
 * =================
 * versione    03
 * copyright   Calzoni Pietro aka Calzo
 * licenza     Dual BSD/GPL
 * --------------------------------------------------------------------------------
 * File header contenente tutte le definizioni necessarie per la gestione delle
 * direttive di IO sul device mediante io-ctl.
 * Riferimenti pag 138 LDD3
 *********************************************************************************/

/** cb_buf  una strtutra che va definita in user-space e contiene la dimensione
 * del buffer e il buffer stesso che andranno caricati internamente al modulo
 * tramite usb
 * */
struct cb_buf
{
   ///Dimensione del buffer, secessaria in quanto il buffer non  a null-termiantion
   unsigned short int dim;
   ///Buffer
   char *buf;
};


#define CB_IOC_MAGIC  0x05 //My IOCTL magic number

/** Definizioni
 * Q: Query - la risposta  nel valore di ritorno
 * S: Set - setta un valore o simile tramite puntatore
 * G: Get - richiede qualche dato tramite un puntatore
 * T: Tell - richiede info diretamente con un argument value
 * */

#define CB_IOCTL_QSIZE   _IO(CB_IOC_MAGIC, 0)
#define CB_IOCTL_QINDEX  _IO(CB_IOC_MAGIC, 1)

///Setta la dimensione del buffer
#define CB_IOCTL_SSIZE   _IOW(CB_IOC_MAGIC, 2, int) //copy_from_user
///Sesetta il contenuto del buffer. Se root, il contenuto pu eccedere da index
#define CB_IOCTL_SBUF    _IOW(CB_IOC_MAGIC, 3, struct cb_buf*) //copy_from_user
///Ottiene il buffer: non si pu portare fuori il buffer se non copiando... ma  troppo pericoloso
//#define CB_IOCTL_GBUF    _IOR(CB_IOC_MAGIC, 4, char*) //copy_to_user


#define CB_IOCTL_MAXNR   0x05 //credo sia il totale delle definizioni... ma secondo me dovrebbe essere 4 ossia il nassimo valore raggiungibile


#endif //__CB_IOCTL__
